<?php

/*
        heurekacz_2010.php
        
        Changelog:
        - 2010-03-19 changed VARIANT to PARAM element -> berushka.net <me@berushka.net>
        - 2010-03-19 based on zbozicz_2010 by <Pot'a>; <lukas@hostingsolutions.cz>

        Copyright 2010 Lukas Potesil <Pot'a>; <lukas@hostingsolutions.cz>
        Copyright 2010 berushka.net <me@berushka.net>

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.
        
        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.
        
        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
        MA 02110-1301, USA.
*/

	/* debug
	ini_set('error_reporting', 6143);
	ini_set('display_errors', 1);
	*/

	header('Expires: ' . gmdate('D, d M Y H:i:s') . '  GMT');
	header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . '  GMT');
	header('Content-Type: application/xml');

	require_once("./config.php");
	require_once(DIR_SYSTEM . 'startup.php');
	require_once(DIR_DATABASE . 'mysql.php');

        // Config
        $config = new Config();

        define('HTTP_SERVER', $config->get('config_url'));
        define('HTTP_IMAGE', HTTP_SERVER . 'image/');

        if ($config->get('config_ssl')) {
                define('HTTPS_SERVER', 'https://' . substr($config->get('config_url'), 0, 7));
                define('HTTPS_IMAGE', HTTPS_SERVER . 'image/');
        } else {
                define('HTTPS_SERVER', HTTP_SERVER);
                define('HTTPS_IMAGE', HTTP_IMAGE);
        }
	$catalog_url = HTTPS_SERVER;
	$image_url = HTTPS_IMAGE;

	$db = new DB(DB_DRIVER, DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);

	print("<?xml version=\"1.0\" encoding=\"utf-8\"?".">\r");

	$query_lang = $db->query("SELECT language_id, code FROM " . DB_PREFIX . "language WHERE code='cs'");
	$lang = $query_lang->row['language_id'];

	$query_products = $db->query("SELECT * FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id=pd.product_id) WHERE pd.language_id='".$lang."'");
	$tax_class_id = $query_products->row['tax_class_id'];

	function product_description($product_description) {
		$product_description = str_replace('&amp;', '&', $product_description);
		$product_description = htmlspecialchars(strip_tags(html_entity_decode($product_description, ENT_QUOTES, 'UTF-8')));
		$product_description = str_replace('&amp;nbsp;', '', $product_description);
		/*$product_description = str_replace('&;', '&amp;', $product_description);*/
		if (strlen($product_description) > 508) {
			$print_description = substr($product_description, 0, 508);
			$pos = strrpos($print_description, ' ');
			$print_description = substr($product_description, 0, $pos) . ' ...';
		} else {
			$print_description = $product_description;
		}
		return $print_description;
	}

	function product_name($product_name) {
		$product_name = htmlspecialchars(strip_tags(html_entity_decode($product_name, ENT_QUOTES, 'UTF-8')));
		if (strlen($product_name) > 60) {
			$print_product_name = substr($product_name, 0, 60);
			$pos = strrpos($print_product_name, ' ');
			$print_product_name = substr($product_name, 0, $pos) . ' ...';
		} else {
			$print_product_name = $product_name;
		}
		return $print_product_name;
	}

	/*
	 * DELIVERY_DATE
	 * mysql> SELECT * FROM stock_status;
	 * hodnota 0: skladem v e-shopu
	 * hodnota 1-7: do týdne
	 * hodnota vyšší než 7: více než týden
	 * jiné hodnoty: neznámá dostupnost
	*/
	/*
        function product_delivery_date($stock_status) {
                if ($stock_status==7) {
                        $print_stock_status = "0";
                }
                if ($stock_status==6) {
                        $print_stock_status = "6";
                }
                if ($stock_status==9 || $stock_status==10 || $stock_status==12 || $stock_status==13 || $stock_status==14 || $stock_status==16) {
                        $print_stock_status = "8";
                }
                if (!isset($print_stock_status)) {
                        $print_stock_status = "nz";
                }
                return $print_stock_status;
        }
        */

        /*
         * PRICE, VAT, PRICE_VAT
         * product_price - cena bez DPH
         * tax_rate      - danova sazba
        */
        function echo_prices($product_price, $tax_rate) {
                $price_vat = $product_price + ($product_price * $tax_rate / 100);
                echo("\n" .
                     "<PRICE>".round($product_price, 2)."</PRICE>\n" .
                     "<VAT>".round($tax_rate, 3)."</VAT>\n" .
                     "<PRICE_VAT>".ceil($price_vat)."</PRICE_VAT>\n"
                );
        }
  
        if (!empty($tax_class_id)) {
                $query_tax_rate = $db->query("SELECT rate, tax_class_id FROM " . DB_PREFIX . "tax_rate WHERE tax_class_id='".$tax_class_id."'");
                $tax_rate = $query_tax_rate->row['rate'];
        }

        echo("<SHOP>\r");

	foreach ($query_products->rows as $product) {
		// DELIVERY DATE
		$query_stock_status = $db->query("SELECT stock_status_id FROM " . DB_PREFIX . "stock_status WHERE stock_status_id='".$product['stock_status_id']."' AND language_id='".$lang."'");
		$stock_status = $query_stock_status->row['stock_status_id'];

		if (!$product['manufacturer_id']==0) {
			$query_manufacturer = $db->query("SELECT name FROM " . DB_PREFIX . "manufacturer WHERE manufacturer_id='".$product['manufacturer_id']."'");
			$manufacturer = $query_manufacturer->row['name'];
		}
		/* // product discount
		$query_product_discount = $db->query("SELECT product_id, price FROM " . DB_PREFIX . "product_discount WHERE product_id='".$product['product_id']."' AND date_end>=NOW() AND customer_group_id='8'");
		 */
		// product special
		$query_product_discount = $db->query("SELECT product_id, price FROM " . DB_PREFIX . "product_special WHERE product_id='".$product['product_id']."' AND customer_group_id='8'");
		if ($query_product_discount->num_rows) {
			$product_price = $query_product_discount->row['price'];
		} else {
			$product_price = $product['price'];
		}
		$product_name = $product['name'];
		$product_description = $product['description'];
		echo("<SHOPITEM>\n" .
                     "<PRODUCT>".product_name($product_name)."</PRODUCT>\n"
		);
		if (!empty($product['meta_description'])) {
			echo("<PRODUCTNAME>".htmlspecialchars(strip_tags(html_entity_decode($product['meta_description'], ENT_QUOTES, 'UTF-8')))."</PRODUCTNAME>\n");
		}
		echo("<DESCRIPTION>".product_description($product_description)."</DESCRIPTION>");
		// delivery date
		if ($product['quantity']>0) {
                        // zboží na skladě
  	                // echo("<DELIVERY_DATE>0</DELIVERY_DATE>");
                } else {
                        // zboží není na skladě
                        // echo("<DELIVERY_DATE>".product_delivery_date($stock_status)."</DELIVERY_DATE>");
		}

		if (!$product['manufacturer_id']==0) {
			echo("<MANUFACTURER>".$manufacturer."</MANUFACTURER>");
		}
		$query_url_alias = $db->query("SELECT keyword FROM " . DB_PREFIX . "url_alias WHERE query='product_id=". $product['product_id']."'");
		if ($query_url_alias->num_rows) {
			echo("<URL>".$catalog_url . $query_url_alias->row['keyword']."</URL>");
		} else {
			echo("<URL>".$catalog_url .'index.php?route=product/product&amp;product_id='. $product['product_id']."</URL>");
		}
		if (!$product['image']==0) {
			echo("<IMGURL>".$image_url . $product['image']."</IMGURL>");
		}
		if (!$product['tax_class_id']==0) {
		  echo_prices($product_price, $tax_rate);
		} else {
			echo("<PRICE_VAT>".round($product_price, 2)."</PRICE_VAT>");
		}
		$query_product_option = $db->query("SELECT ov.quantity, ov.price, ovd.name as value, od.name " .
                                                   "FROM " . DB_PREFIX . "product_option_value ov, " .
                                                             DB_PREFIX . "product_option_value_description ovd, " .
                                                             DB_PREFIX . "product_option_description od " .
                                                   "WHERE ov.product_option_value_id = ovd.product_option_value_id AND " .
                                                         "ov.product_option_id = od.product_option_id AND " .
                                                         "od.product_id = '" . $product['product_id'] . "' AND " .
                                                         "od.language_id='5'");
                // PARAM
                if ($query_product_option->num_rows>0) {
                        echo("<PARAM>");
                        $i = 1;
    		        foreach ($query_product_option->rows as $product_option) {
                                if ($i==1) {
                                        echo("<PARAM_NAME>" . product_name($product_option['name']) . "</PARAM_NAME>");
                                        echo("<VAL>");
                                }
                                echo(product_name($product_option['value']));
                                if ($i<$query_product_option->num_rows) {
                                        echo(";");
                                } else {
                                        echo("</VAL>");
                                }
                                $i += 1;
                        }
                        echo("</PARAM>\n");
		}
		echo("</SHOPITEM>\n");
	}
	echo("</SHOP>\r");

?>
